"""
Django settings for ticketlobby project.

Generated by 'django-admin startproject' using Django 3.1.4.

For more information on this file, see
https://docs.djangoproject.com/en/3.1/topics/settings/

For the full list of settings and their values, see
https://docs.djangoproject.com/en/3.1/ref/settings/
"""

from pathlib import Path
import os
from decouple import config
from django.core.exceptions import ImproperlyConfigured

# Build paths inside the project like this: BASE_DIR / 'subdir'.
BASE_DIR = os.path.dirname(os.path.dirname(os.path.abspath(__file__)))

# Quick-start development settings - unsuitable for production
# See https://docs.djangoproject.com/en/3.1/howto/deployment/checklist/

# SECURITY WARNING: keep the secret key used in production secret!
SECRET_KEY = config('SECRET_KEY')

# SECURITY WARNING: don't run with debug turned on in production!
DEBUG = config('DEBUG', cast=bool)

ALLOWED_HOSTS = config(
    'ALLOWED_HOSTS', 
    cast=lambda v: [s.strip() for s in v.split(',')]
    )
# Application definition

INSTALLED_APPS = [
    'django.contrib.admin',
    'django.contrib.auth',
    'django.contrib.contenttypes',
    'django.contrib.sessions',
    'django.contrib.messages',
    'django.contrib.staticfiles',
    'markdownify',
    'rest_framework',
    'shared.apps.SharedConfig',
    'anonticket.apps.AnonticketConfig',
    'ircbot',
]

MIDDLEWARE = [
    'shared.middleware.reverse_proxy_ip.XForwardedForMiddleware',
    'django.middleware.security.SecurityMiddleware',
    'django.contrib.sessions.middleware.SessionMiddleware',
    'django.middleware.common.CommonMiddleware',
    'django.middleware.csrf.CsrfViewMiddleware',
    'django.contrib.auth.middleware.AuthenticationMiddleware',
    'django.contrib.messages.middleware.MessageMiddleware',
    'django.middleware.clickjacking.XFrameOptionsMiddleware',
]

ROOT_URLCONF = 'ticketlobby.urls'

TEMPLATES = [
    {
        'BACKEND': 'django.template.backends.django.DjangoTemplates',
        'DIRS': [],
        'APP_DIRS': True,
        'OPTIONS': {
            'context_processors': [
                'django.template.context_processors.debug',
                'django.template.context_processors.request',
                'django.contrib.auth.context_processors.auth',
                'django.contrib.messages.context_processors.messages',
            ],
        },
    },
]

WSGI_APPLICATION = 'ticketlobby.wsgi.application'


# Database
# https://docs.djangoproject.com/en/3.1/ref/settings/#databases

DATABASES = {
    'default': {
        'ENGINE': 'django.db.backends.sqlite3',
        'NAME': os.path.join(BASE_DIR, 'db.sqlite3'),
    }
}

# Caching - necessary for Django-Ratelimit

CACHES = {
    'default': {
        'BACKEND': 'django.core.cache.backends.locmem.LocMemCache',
    }
}

# Password validation
# https://docs.djangoproject.com/en/3.1/ref/settings/#auth-password-validators

AUTH_PASSWORD_VALIDATORS = [
    {
        'NAME': 'django.contrib.auth.password_validation.UserAttributeSimilarityValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.MinimumLengthValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.CommonPasswordValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.NumericPasswordValidator',
    },
]


# Internationalization
# https://docs.djangoproject.com/en/3.1/topics/i18n/

LANGUAGE_CODE = 'en-us'

TIME_ZONE = 'UTC'

USE_I18N = True

USE_L10N = True

USE_TZ = True

# Static files (CSS, JavaScript, Images)
# https://docs.djangoproject.com/en/3.1/howto/static-files/

STATIC_URL = '/static/'
STATIC_ROOT = os.path.join(BASE_DIR, 'static')

# Gitlab Settings for python-gitlab/gitlab API

# SECURITY WARNING: GitLab credentials.
GITLAB_URL = config('GITLAB_URL', default='')
GITLAB_SECRET_TOKEN = config('GITLAB_SECRET_TOKEN', default='')
# ACCOUNTS_SECRET_TOKEN is for GitlabAccountCreation
GITLAB_ACCOUNTS_SECRET_TOKEN = config('GITLAB_ACCOUNTS_SECRET_TOKEN', default='')

# Set amount of seconds before timeout when making GitLab API calls
GITLAB_TIMEOUT = config('GITLAB_TIMEOUT', default=10, cast=int)
# Timeout URL used for testing GL bot 
TIMEOUT_URL = config('TIMEOUT_URL', default='')

# Configuration settings for Django Ratelimit
MAIN_RATE_GROUP = config('MAIN_RATE_GROUP', default='')
LIMIT_RATE = config('LIMIT_RATE', default='100/m')
BLOCK_ALL = config('BLOCK_ALL', default=False, cast=bool)

# Wordlist Settings for generating wordlist
WORD_LIST_PATH = os.path.join(BASE_DIR, 'shared/wordlist.txt')
DICE_ROLLS = 6

REJECT_EMAIL_DOMAINS = os.path.join(BASE_DIR, "shared/reject_domains.txt")

DEFAULT_AUTO_FIELD = 'django.db.models.AutoField'

try:
    from .local import *
except ImportError:
    print("no local.py file")
